// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "11/22/2011 16:09:29"

// Verilog Test Bench template for design : AD7401
//
// Simulation tool : ModelSim-Altera (Verilog)
//

`timescale 1 ns / 100 ps
module AD7401_vlg_tst();
// test vector input registers
reg [15:0] adc_db_i;
reg fpga_clk_i;
reg adc_clk_i;
reg reset_n_i;
reg adc_mdat_i;
reg [15:0] adc_mdat_ref;
reg [15:0] adc_mdat_reg;

// wires
wire [15:0]  data_o;
wire data_rd_ready_o;
wire adc_mclkin_o;

// assign statements (if any)

AD7401 i1 (
// port map - connection between master ports and signals/registers
    .fpga_clk_i(fpga_clk_i),
    .adc_clk_i(adc_clk_i),
    .reset_n_i(reset_n_i),

    .data_o(data_o),
    .data_rd_ready_o(data_rd_ready_o),

    .adc_mdat_i(adc_mdat_i),
    .adc_mclkin_o(adc_mclkin_o)
);
initial
begin
    adc_db_i        = 16'h0;
    fpga_clk_i      = 1'b0;
    adc_clk_i       = 1'b0;
    adc_mdat_ref    = 16'h0001;
    adc_mdat_reg    = 16'h1;
    adc_mdat_i      = 1'b0;
    reset_n_i       = 0;
#100
    reset_n_i   = 1;
#100
$display("Running testbench");
end


//main clock generation
always
begin
    #10.4 fpga_clk_i <= ~fpga_clk_i;
end

always
begin
    #26 adc_clk_i <= ~adc_clk_i;    //19.2 MHz
end

always
begin
    #1000000 adc_mdat_ref   = ((adc_mdat_ref << 1) + 16'h1);
    adc_mdat_reg            = adc_mdat_ref;
end

always @(posedge adc_mclkin_o)
begin
    #10 adc_mdat_i = 1'bX;
    adc_mdat_reg   = {adc_mdat_reg[14:0],adc_mdat_reg[15]};
    #30 adc_mdat_i = adc_mdat_reg[15];
end

endmodule

